/*
 * crypto_hash/try.c version 20180227
 * D. J. Bernstein
 * Public domain.
 * Auto-generated by trygen.py; do not edit.
 */

#include "crypto_hash.h"
#include "try.h"

const char *primitiveimplementation = crypto_hash_implementation;

#define TUNE_BYTES 1536
#ifdef SMALL
#define MAXTEST_BYTES 128
#else
#define MAXTEST_BYTES 4096
#endif
#ifdef SMALL
#define LOOPS 64
#else
#define LOOPS 512
#endif

static unsigned char *h;
static unsigned char *m;
static unsigned char *h2;
static unsigned char *m2;
#define hlen crypto_hash_BYTES
unsigned long long mlen;

void preallocate(void)
{
}

void allocate(void)
{
  unsigned long long alloclen = 0;
  if (alloclen < TUNE_BYTES) alloclen = TUNE_BYTES;
  if (alloclen < MAXTEST_BYTES) alloclen = MAXTEST_BYTES;
  if (alloclen < crypto_hash_BYTES) alloclen = crypto_hash_BYTES;
  h = alignedcalloc(alloclen);
  m = alignedcalloc(alloclen);
  h2 = alignedcalloc(alloclen);
  m2 = alignedcalloc(alloclen);
}

void predoit(void)
{
}

void doit(void)
{
  crypto_hash(h,m,TUNE_BYTES);
}

void test(void)
{
  unsigned long long loop;
  
  for (loop = 0;loop < LOOPS;++loop) {
    mlen = myrandom() % (MAXTEST_BYTES + 1);
    
    output_prepare(h2,h,hlen);
    input_prepare(m2,m,mlen);
    if (crypto_hash(h,m,mlen) != 0) fail("crypto_hash returns nonzero");
    checksum(h,hlen);
    output_compare(h2,h,hlen,"crypto_hash");
    input_compare(m2,m,mlen,"crypto_hash");
    
    double_canary(h2,h,hlen);
    double_canary(m2,m,mlen);
    if (crypto_hash(h2,m2,mlen) != 0) fail("crypto_hash returns nonzero");
    if (memcmp(h2,h,hlen) != 0) fail("crypto_hash is nondeterministic");
    
    double_canary(h2,h,hlen);
    double_canary(m2,m,mlen);
    if (crypto_hash(m2,m2,mlen) != 0) fail("crypto_hash with m=h overlap returns nonzero");
    if (memcmp(m2,h,hlen) != 0) fail("crypto_hash does not handle m=h overlap");
    memcpy(m2,m,mlen);
  }
}
